"use strict";
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseArgsArray = parseArgsArray;
exports.formatArgNameWithAlias = formatArgNameWithAlias;
function parseArgsArray(argv) {
    var foundIndex = argv.findIndex(function (x) { return x.startsWith('-'); });
    var optionalBegin = foundIndex !== -1 ? foundIndex : argv.length;
    var positional = __spreadArray([], __read(argv.slice(0, optionalBegin)), false);
    var optionalBuffer = __spreadArray([], __read(argv.slice(optionalBegin)), false).reverse();
    var optional = {};
    var argName = undefined;
    var argValues = [];
    while (optionalBuffer.length > 0) {
        var item = optionalBuffer.pop();
        if (item.match(/^-[a-zA-Z0-9]{2,}$/)) {
            var items = item.slice(1).split('').reverse();
            optionalBuffer.push.apply(optionalBuffer, __spreadArray([], __read(items.map(function (x) { return "-".concat(x); })), false));
            continue;
        }
        if (item.startsWith('-')) {
            if (argName !== undefined) {
                optional[argName] = argValues;
            }
            argName = item;
            argValues = [];
        }
        else {
            argValues.push(item);
        }
    }
    if (argName !== undefined) {
        optional[argName] = argValues;
    }
    return [positional, optional];
}
/**
 * Formats the argument name with alias.
 *
 * @param argConfig - The argument configuration.
 *
 * @returns The formatted argument name.
 *
 * @category Utils
 */
function formatArgNameWithAlias(argConfig) {
    return "".concat(argConfig.name).concat(argConfig.alias ? " (".concat(argConfig.alias, ")") : '');
}
//# sourceMappingURL=utils.js.map